Package java.lang

## Class Enum<E extends Enum<E>>

- java.lang.Object
- - java.lang.Enum<E>

- Type Parameters:
    `E` - The enum type subclass
  All Implemented Interfaces:
    `Serializable`, `Comparable<E>`

      public abstract class Enum<E extends Enum<E>>
      extends Object
      implements Comparable<E>, Serializable

  This is the common base class of all Java language enumeration types. More information about enums, including descriptions of the implicitly declared methods synthesized by the compiler, can be found in section 8.9 of The Java™ Language Specification.
  See Also:
    Serialized Form

- - ### Constructor Summary

    Constructors
    Modifier | Constructor | Description
    --- | --- | ---
    `protected` | `Enum​(String name, int ordinal)` | Sole constructor.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `int` | `compareTo​(E o)` | Compares this enum with the specified object for order.
    `boolean` | `equals​(Object other)` | Returns true if the specified object is equal to this enum constant.
    `int` | `hashCode()` | Returns a hash code for this enum constant.
    `String` | `name()` | Returns the name of this enum constant, exactly as declared in its enum declaration.
    `int` | `ordinal()` | Returns the ordinal of this enumeration constant (its position in its enum declaration, where the initial constant is assigned an ordinal of zero).
    `String` | `toString()` | Returns the name of this enum constant, as contained in the declaration.
    `static <T extends Enum<T>> T` | `valueOf​(Class<T> enumType, String name)` | This method is available for compilation purpose.

    - ### Methods inherited from class java.lang.Object

      `clone, getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### Enum

          protected Enum​(String name,
                         int ordinal)

      Sole constructor. Programmers cannot invoke this constructor. It is for use by code emitted by the compiler in response to enum type declarations.
      Parameters:
        `name` - - The name of this enum constant, which is the identifier used to declare it.
        `ordinal` - - The ordinal of this enumeration constant (its position in the enum declaration, where the initial constant is assigned an ordinal of zero).

  - ### Method Detail

    - #### valueOf

          public static <T extends Enum<T>> T valueOf​(Class<T> enumType,
                                                      String name)

      This method is available for compilation purpose.
      Type Parameters:
        `T` - the enum type whose constant is to be returned
      Parameters:
        `enumType` - the Class object of the enum type from which to return a constant
        `name` - the name of the constant to return
      Returns:
        the enum constant of the specified enum type with the specified name
      Throws:
        `NoSuchMethodError` - always

    - #### compareTo

          public final int compareTo​(E o)

      Compares this enum with the specified object for order. Returns a negative integer, zero, or a positive integer as this object is less than, equal to, or greater than the specified object. Enum constants are only comparable to other enum constants of the same enum type. The natural order implemented by this method is the order in which the constants are declared.
      Specified by:
        `compareTo` in interface `Comparable<E extends Enum<E>>`
      Parameters:
        `o` - the object to be compared.
      Returns:
        a negative integer, zero, or a positive integer as this object is less than, equal to, or greater than the specified object.

    - #### equals

          public final boolean equals​(@Nullable
                                      Object other)

      Returns true if the specified object is equal to this enum constant.
      Overrides:
        `equals` in class `Object`
      Parameters:
        `other` - the object to be compared for equality with this object.
      Returns:
        true if the specified object is equal to this enum constant.
      See Also:
        `Object.hashCode()`, `HashMap`

    - #### hashCode

          public final int hashCode()

      Returns a hash code for this enum constant.
      Overrides:
        `hashCode` in class `Object`
      Returns:
        a hash code for this enum constant.
      See Also:
        `Object.equals(java.lang.Object)`, `System.identityHashCode(java.lang.Object)`

    - #### name

          public final String name()

      Returns the name of this enum constant, exactly as declared in its enum declaration. Most programmers should use the `toString()` method in preference to this one, as the toString method may return a more user-friendly name. This method is designed primarily for use in specialized situations where correctness depends on getting the exact name, which will not vary from release to release.
      Returns:
        the name of this enum constant

    - #### ordinal

          public final int ordinal()

      Returns the ordinal of this enumeration constant (its position in its enum declaration, where the initial constant is assigned an ordinal of zero).
      Returns:
        the ordinal of this enumeration constant

    - #### toString

          public String toString()

      Returns the name of this enum constant, as contained in the declaration. This method may be overridden, though it typically isn't necessary or desirable. An enum type should override this method when a more "programmer-friendly" string form exists.
      Overrides:
        `toString` in class `Object`
      Returns:
        the name of this enum constant